import { NG_VALUE_ACCESSOR, NG_VALIDATORS, FormsModule } from '@angular/forms';
import { Directive, TemplateRef, Input, forwardRef, Component, ChangeDetectorRef, ViewChild, ContentChild, ContentChildren, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function RuleSet() { }
if (false) {
    /** @type {?} */
    RuleSet.prototype.condition;
    /** @type {?} */
    RuleSet.prototype.rules;
    /** @type {?|undefined} */
    RuleSet.prototype.collapsed;
    /** @type {?|undefined} */
    RuleSet.prototype.isChild;
}
/**
 * @record
 */
function Rule() { }
if (false) {
    /** @type {?} */
    Rule.prototype.field;
    /** @type {?|undefined} */
    Rule.prototype.value;
    /** @type {?|undefined} */
    Rule.prototype.operator;
    /** @type {?|undefined} */
    Rule.prototype.entity;
}
/**
 * @record
 */
function Option() { }
if (false) {
    /** @type {?} */
    Option.prototype.name;
    /** @type {?} */
    Option.prototype.value;
}
/**
 * @record
 */
function FieldMap() { }
/**
 * @record
 */
function Field() { }
if (false) {
    /** @type {?} */
    Field.prototype.name;
    /** @type {?|undefined} */
    Field.prototype.value;
    /** @type {?} */
    Field.prototype.type;
    /** @type {?|undefined} */
    Field.prototype.nullable;
    /** @type {?|undefined} */
    Field.prototype.options;
    /** @type {?|undefined} */
    Field.prototype.operators;
    /** @type {?|undefined} */
    Field.prototype.defaultValue;
    /** @type {?|undefined} */
    Field.prototype.defaultOperator;
    /** @type {?|undefined} */
    Field.prototype.entity;
    /** @type {?|undefined} */
    Field.prototype.validator;
}
/**
 * @record
 */
function LocalRuleMeta() { }
if (false) {
    /** @type {?} */
    LocalRuleMeta.prototype.ruleset;
    /** @type {?} */
    LocalRuleMeta.prototype.invalid;
}
/**
 * @record
 */
function EntityMap() { }
/**
 * @record
 */
function Entity() { }
if (false) {
    /** @type {?} */
    Entity.prototype.name;
    /** @type {?|undefined} */
    Entity.prototype.value;
    /** @type {?|undefined} */
    Entity.prototype.defaultField;
}
/**
 * @record
 */
function QueryBuilderClassNames() { }
if (false) {
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.arrowIconButton;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.arrowIcon;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.removeIcon;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.addIcon;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.button;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.buttonGroup;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.removeButton;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.removeButtonSize;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.switchRow;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.switchGroup;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.switchLabel;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.switchRadio;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.switchControl;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.rightAlign;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.transition;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.collapsed;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.treeContainer;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.tree;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.row;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.connector;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.rule;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.ruleSet;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.invalidRuleSet;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.emptyWarning;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.fieldControl;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.fieldControlSize;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.entityControl;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.entityControlSize;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.operatorControl;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.operatorControlSize;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.inputControl;
    /** @type {?|undefined} */
    QueryBuilderClassNames.prototype.inputControlSize;
}
/**
 * @record
 */
function QueryBuilderConfig() { }
if (false) {
    /** @type {?} */
    QueryBuilderConfig.prototype.fields;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.entities;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.allowEmptyRulesets;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.getOperators;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.getInputType;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.getOptions;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.addRuleSet;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.addRule;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.removeRuleSet;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.removeRule;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.coerceValueForOperator;
    /** @type {?|undefined} */
    QueryBuilderConfig.prototype.calculateFieldChangeValue;
}
/**
 * @record
 */
function SwitchGroupContext() { }
if (false) {
    /** @type {?} */
    SwitchGroupContext.prototype.onChange;
    /** @type {?} */
    SwitchGroupContext.prototype.getDisabledState;
    /** @type {?} */
    SwitchGroupContext.prototype.$implicit;
}
/**
 * @record
 */
function EmptyWarningContext() { }
if (false) {
    /** @type {?} */
    EmptyWarningContext.prototype.getDisabledState;
    /** @type {?} */
    EmptyWarningContext.prototype.message;
    /** @type {?} */
    EmptyWarningContext.prototype.$implicit;
}
/**
 * @record
 */
function ArrowIconContext() { }
if (false) {
    /** @type {?} */
    ArrowIconContext.prototype.getDisabledState;
    /** @type {?} */
    ArrowIconContext.prototype.$implicit;
}
/**
 * @record
 */
function EntityContext() { }
if (false) {
    /** @type {?} */
    EntityContext.prototype.onChange;
    /** @type {?} */
    EntityContext.prototype.getDisabledState;
    /** @type {?} */
    EntityContext.prototype.entities;
    /** @type {?} */
    EntityContext.prototype.$implicit;
}
/**
 * @record
 */
function FieldContext() { }
if (false) {
    /** @type {?} */
    FieldContext.prototype.onChange;
    /** @type {?} */
    FieldContext.prototype.getFields;
    /** @type {?} */
    FieldContext.prototype.getDisabledState;
    /** @type {?} */
    FieldContext.prototype.fields;
    /** @type {?} */
    FieldContext.prototype.$implicit;
}
/**
 * @record
 */
function OperatorContext() { }
if (false) {
    /** @type {?} */
    OperatorContext.prototype.onChange;
    /** @type {?} */
    OperatorContext.prototype.getDisabledState;
    /** @type {?} */
    OperatorContext.prototype.operators;
    /** @type {?} */
    OperatorContext.prototype.$implicit;
}
/**
 * @record
 */
function InputContext() { }
if (false) {
    /** @type {?} */
    InputContext.prototype.onChange;
    /** @type {?} */
    InputContext.prototype.getDisabledState;
    /** @type {?} */
    InputContext.prototype.options;
    /** @type {?} */
    InputContext.prototype.field;
    /** @type {?} */
    InputContext.prototype.$implicit;
}
/**
 * @record
 */
function ButtonGroupContext() { }
if (false) {
    /** @type {?} */
    ButtonGroupContext.prototype.addRule;
    /** @type {?} */
    ButtonGroupContext.prototype.addRuleSet;
    /** @type {?} */
    ButtonGroupContext.prototype.removeRuleSet;
    /** @type {?} */
    ButtonGroupContext.prototype.getDisabledState;
    /** @type {?} */
    ButtonGroupContext.prototype.$implicit;
}
/**
 * @record
 */
function RemoveButtonContext() { }
if (false) {
    /** @type {?} */
    RemoveButtonContext.prototype.removeRule;
    /** @type {?} */
    RemoveButtonContext.prototype.getDisabledState;
    /** @type {?} */
    RemoveButtonContext.prototype.$implicit;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryOperatorDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryOperatorDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryOperator]' },] }
];
/** @nocollapse */
QueryOperatorDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryOperatorDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryFieldDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryFieldDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryField]' },] }
];
/** @nocollapse */
QueryFieldDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryFieldDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryEntityDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryEntityDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryEntity]' },] }
];
/** @nocollapse */
QueryEntityDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryEntityDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QuerySwitchGroupDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QuerySwitchGroupDirective.decorators = [
    { type: Directive, args: [{ selector: '[querySwitchGroup]' },] }
];
/** @nocollapse */
QuerySwitchGroupDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QuerySwitchGroupDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryButtonGroupDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryButtonGroupDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryButtonGroup]' },] }
];
/** @nocollapse */
QueryButtonGroupDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryButtonGroupDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryInputDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
    /**
     * Unique name for query input type.
     * @return {?}
     */
    get queryInputType() { return this._type; }
    /**
     * @param {?} value
     * @return {?}
     */
    set queryInputType(value) {
        // If the directive is set without a type (updated programatically), then this setter will
        // trigger with an empty string and should not overwrite the programatically set value.
        if (!value) {
            return;
        }
        this._type = value;
    }
}
QueryInputDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryInput]' },] }
];
/** @nocollapse */
QueryInputDirective.ctorParameters = () => [
    { type: TemplateRef }
];
QueryInputDirective.propDecorators = {
    queryInputType: [{ type: Input }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    QueryInputDirective.prototype._type;
    /** @type {?} */
    QueryInputDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryRemoveButtonDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryRemoveButtonDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryRemoveButton]' },] }
];
/** @nocollapse */
QueryRemoveButtonDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryRemoveButtonDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryEmptyWarningDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryEmptyWarningDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryEmptyWarning]' },] }
];
/** @nocollapse */
QueryEmptyWarningDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryEmptyWarningDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryArrowIconDirective {
    /**
     * @param {?} template
     */
    constructor(template) {
        this.template = template;
    }
}
QueryArrowIconDirective.decorators = [
    { type: Directive, args: [{ selector: '[queryArrowIcon]' },] }
];
/** @nocollapse */
QueryArrowIconDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /** @type {?} */
    QueryArrowIconDirective.prototype.template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef((/**
     * @return {?}
     */
    () => QueryBuilderComponent)),
    multi: true
};
/** @type {?} */
const VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef((/**
     * @return {?}
     */
    () => QueryBuilderComponent)),
    multi: true
};
class QueryBuilderComponent {
    /**
     * @param {?} changeDetectorRef
     */
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.defaultClassNames = {
            arrowIconButton: 'q-arrow-icon-button',
            arrowIcon: 'q-icon q-arrow-icon',
            removeIcon: 'q-icon q-remove-icon',
            addIcon: 'q-icon q-add-icon',
            button: 'q-button',
            buttonGroup: 'q-button-group',
            removeButton: 'q-remove-button',
            switchGroup: 'q-switch-group',
            switchLabel: 'q-switch-label',
            switchRadio: 'q-switch-radio',
            rightAlign: 'q-right-align',
            transition: 'q-transition',
            collapsed: 'q-collapsed',
            treeContainer: 'q-tree-container',
            tree: 'q-tree',
            row: 'q-row',
            connector: 'q-connector',
            rule: 'q-rule',
            ruleSet: 'q-ruleset',
            invalidRuleSet: 'q-invalid-ruleset',
            emptyWarning: 'q-empty-warning',
            fieldControl: 'q-field-control',
            fieldControlSize: 'q-control-size',
            entityControl: 'q-entity-control',
            entityControlSize: 'q-control-size',
            operatorControl: 'q-operator-control',
            operatorControlSize: 'q-control-size',
            inputControl: 'q-input-control',
            inputControlSize: 'q-control-size'
        };
        this.defaultOperatorMap = {
            string: ['=', '!=', 'contains', 'like'],
            number: ['=', '!=', '>', '>=', '<', '<='],
            time: ['=', '!=', '>', '>=', '<', '<='],
            date: ['=', '!=', '>', '>=', '<', '<='],
            category: ['=', '!=', 'in', 'not in'],
            boolean: ['=']
        };
        this.data = { condition: 'and', rules: [] };
        this.allowRuleset = true;
        this.allowCollapse = false;
        this.emptyMessage = 'A ruleset cannot be empty. Please add a rule or remove it all together.';
        this.config = { fields: {} };
        this.persistValueOnFieldChange = false;
        this.defaultTemplateTypes = [
            'string', 'number', 'time', 'date', 'category', 'boolean', 'multiselect'
        ];
        this.defaultPersistValueTypes = [
            'string', 'number', 'time', 'date', 'boolean'
        ];
        this.defaultEmptyList = [];
        this.inputContextCache = new Map();
        this.operatorContextCache = new Map();
        this.fieldContextCache = new Map();
        this.entityContextCache = new Map();
        this.removeButtonContextCache = new Map();
        // ----------END----------
        this.getDisabledState = (/**
         * @return {?}
         */
        () => {
            return this.disabled;
        });
    }
    // ----------OnInit Implementation----------
    /**
     * @return {?}
     */
    ngOnInit() { }
    // ----------OnChanges Implementation----------
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        const config = this.config;
        /** @type {?} */
        const type = typeof config;
        if (type === 'object') {
            this.fields = Object.keys(config.fields).map((/**
             * @param {?} value
             * @return {?}
             */
            (value) => {
                /** @type {?} */
                const field = config.fields[value];
                field.value = field.value || value;
                return field;
            }));
            if (config.entities) {
                this.entities = Object.keys(config.entities).map((/**
                 * @param {?} value
                 * @return {?}
                 */
                (value) => {
                    /** @type {?} */
                    const entity = config.entities[value];
                    entity.value = entity.value || value;
                    return entity;
                }));
            }
            else {
                this.entities = null;
            }
            this.operatorsCache = {};
        }
        else {
            throw new Error(`Expected 'config' must be a valid object, got ${type} instead.`);
        }
    }
    // ----------Validator Implementation----------
    /**
     * @param {?} control
     * @return {?}
     */
    validate(control) {
        /** @type {?} */
        const errors = {};
        /** @type {?} */
        const ruleErrorStore = [];
        /** @type {?} */
        let hasErrors = false;
        if (!this.config.allowEmptyRulesets && this.checkEmptyRuleInRuleset(this.data)) {
            errors.empty = 'Empty rulesets are not allowed.';
            hasErrors = true;
        }
        this.validateRulesInRuleset(this.data, ruleErrorStore);
        if (ruleErrorStore.length) {
            errors.rules = ruleErrorStore;
            hasErrors = true;
        }
        return hasErrors ? errors : null;
    }
    // ----------ControlValueAccessor Implementation----------
    /**
     * @return {?}
     */
    get value() {
        return this.data;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) {
        // When component is initialized without a formControl, null is passed to value
        this.data = value || { condition: 'and', rules: [] };
        this.handleDataChange();
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    writeValue(obj) {
        this.value = obj;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChangeCallback = (/**
         * @return {?}
         */
        () => fn(this.data));
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouchedCallback = (/**
         * @return {?}
         */
        () => fn(this.data));
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
        this.changeDetectorRef.detectChanges();
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    findTemplateForRule(rule) {
        /** @type {?} */
        const type = this.getInputType(rule.field, rule.operator);
        if (type) {
            /** @type {?} */
            const queryInput = this.findQueryInput(type);
            if (queryInput) {
                return queryInput.template;
            }
            else {
                if (this.defaultTemplateTypes.indexOf(type) === -1) {
                    console.warn(`Could not find template for field with type: ${type}`);
                }
                return null;
            }
        }
    }
    /**
     * @param {?} type
     * @return {?}
     */
    findQueryInput(type) {
        /** @type {?} */
        const templates = this.parentInputTemplates || this.inputTemplates;
        return templates.find((/**
         * @param {?} item
         * @return {?}
         */
        (item) => item.queryInputType === type));
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getOperators(field) {
        if (this.operatorsCache[field]) {
            return this.operatorsCache[field];
        }
        /** @type {?} */
        let operators = this.defaultEmptyList;
        /** @type {?} */
        const fieldObject = this.config.fields[field];
        if (this.config.getOperators) {
            return this.config.getOperators(field, fieldObject);
        }
        /** @type {?} */
        const type = fieldObject.type;
        if (fieldObject && fieldObject.operators) {
            operators = fieldObject.operators;
        }
        else if (type) {
            operators = (this.operatorMap && this.operatorMap[type]) || this.defaultOperatorMap[type] || this.defaultEmptyList;
            if (operators.length === 0) {
                console.warn(`No operators found for field '${field}' with type ${fieldObject.type}. ` +
                    `Please define an 'operators' property on the field or use the 'operatorMap' binding to fix this.`);
            }
            if (fieldObject.nullable) {
                operators = operators.concat(['is null', 'is not null']);
            }
        }
        else {
            console.warn(`No 'type' property found on field: '${field}'`);
        }
        // Cache reference to array object, so it won't be computed next time and trigger a rerender.
        this.operatorsCache[field] = operators;
        return operators;
    }
    /**
     * @param {?} entity
     * @return {?}
     */
    getFields(entity) {
        if (this.entities && entity) {
            return this.fields.filter((/**
             * @param {?} field
             * @return {?}
             */
            (field) => {
                return field && field.entity === entity;
            }));
        }
        else {
            return this.fields;
        }
    }
    /**
     * @param {?} field
     * @param {?} operator
     * @return {?}
     */
    getInputType(field, operator) {
        if (this.config.getInputType) {
            return this.config.getInputType(field, operator);
        }
        if (!this.config.fields[field]) {
            throw new Error(`No configuration for field '${field}' could be found! Please add it to config.fields.`);
        }
        /** @type {?} */
        const type = this.config.fields[field].type;
        switch (operator) {
            case 'is null':
            case 'is not null':
                return null; // No displayed component
            case 'in':
            case 'not in':
                return type === 'category' || type === 'boolean' ? 'multiselect' : type;
            default:
                return type;
        }
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getOptions(field) {
        if (this.config.getOptions) {
            return this.config.getOptions(field);
        }
        return this.config.fields[field].options || this.defaultEmptyList;
    }
    /**
     * @param {...?} args
     * @return {?}
     */
    getClassNames(...args) {
        /** @type {?} */
        const clsLookup = this.classNames ? this.classNames : this.defaultClassNames;
        /** @type {?} */
        const classNames = args.map((/**
         * @param {?} id
         * @return {?}
         */
        (id) => clsLookup[id] || this.defaultClassNames[id])).filter((/**
         * @param {?} c
         * @return {?}
         */
        (c) => !!c));
        return classNames.length ? classNames.join(' ') : null;
    }
    /**
     * @param {?} entity
     * @return {?}
     */
    getDefaultField(entity) {
        if (!entity) {
            return null;
        }
        else if (entity.defaultField !== undefined) {
            return this.getDefaultValue(entity.defaultField);
        }
        else {
            /** @type {?} */
            const entityFields = this.fields.filter((/**
             * @param {?} field
             * @return {?}
             */
            (field) => {
                return field && field.entity === entity.value;
            }));
            if (entityFields && entityFields.length) {
                return entityFields[0];
            }
            else {
                console.warn(`No fields found for entity '${entity.name}'. ` +
                    `A 'defaultOperator' is also not specified on the field config. Operator value will default to null.`);
                return null;
            }
        }
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getDefaultOperator(field) {
        if (field && field.defaultOperator !== undefined) {
            return this.getDefaultValue(field.defaultOperator);
        }
        else {
            /** @type {?} */
            const operators = this.getOperators(field.value);
            if (operators && operators.length) {
                return operators[0];
            }
            else {
                console.warn(`No operators found for field '${field.value}'. ` +
                    `A 'defaultOperator' is also not specified on the field config. Operator value will default to null.`);
                return null;
            }
        }
    }
    /**
     * @param {?=} parent
     * @return {?}
     */
    addRule(parent) {
        if (this.disabled) {
            return;
        }
        parent = parent || this.data;
        if (this.config.addRule) {
            this.config.addRule(parent);
        }
        else {
            /** @type {?} */
            const field = this.fields[0];
            parent.rules = parent.rules.concat([{
                    field: field.value,
                    operator: this.getDefaultOperator(field),
                    value: this.getDefaultValue(field.defaultValue),
                    entity: field.entity
                }]);
        }
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} rule
     * @param {?=} parent
     * @return {?}
     */
    removeRule(rule, parent) {
        if (this.disabled) {
            return;
        }
        parent = parent || this.data;
        if (this.config.removeRule) {
            this.config.removeRule(rule, parent);
        }
        else {
            parent.rules = parent.rules.filter((/**
             * @param {?} r
             * @return {?}
             */
            (r) => r !== rule));
        }
        this.inputContextCache.delete(rule);
        this.operatorContextCache.delete(rule);
        this.fieldContextCache.delete(rule);
        this.entityContextCache.delete(rule);
        this.removeButtonContextCache.delete(rule);
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?=} parent
     * @return {?}
     */
    addRuleSet(parent) {
        if (this.disabled) {
            return;
        }
        parent = parent || this.data;
        if (this.config.addRuleSet) {
            this.config.addRuleSet(parent);
        }
        else {
            parent.rules = parent.rules.concat([{ condition: 'and', rules: [] }]);
        }
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?=} ruleset
     * @param {?=} parent
     * @return {?}
     */
    removeRuleSet(ruleset, parent) {
        if (this.disabled) {
            return;
        }
        ruleset = ruleset || this.data;
        parent = parent || this.parentValue;
        if (this.config.removeRuleSet) {
            this.config.removeRuleSet(ruleset, parent);
        }
        else {
            parent.rules = parent.rules.filter((/**
             * @param {?} r
             * @return {?}
             */
            (r) => r !== ruleset));
        }
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} e
     * @return {?}
     */
    transitionEnd(e) {
        this.treeContainer.nativeElement.style.maxHeight = null;
    }
    /**
     * @return {?}
     */
    toggleCollapse() {
        this.computedTreeContainerHeight();
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.data.collapsed = !this.data.collapsed;
        }), 100);
    }
    /**
     * @return {?}
     */
    computedTreeContainerHeight() {
        /** @type {?} */
        const nativeElement = this.treeContainer.nativeElement;
        if (nativeElement && nativeElement.firstElementChild) {
            nativeElement.style.maxHeight = (nativeElement.firstElementChild.clientHeight + 8) + 'px';
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    changeCondition(value) {
        if (this.disabled) {
            return;
        }
        this.data.condition = value;
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    changeOperator(rule) {
        if (this.disabled) {
            return;
        }
        if (this.config.coerceValueForOperator) {
            rule.value = this.config.coerceValueForOperator(rule.operator, rule.value, rule);
        }
        else {
            rule.value = this.coerceValueForOperator(rule.operator, rule.value, rule);
        }
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} operator
     * @param {?} value
     * @param {?} rule
     * @return {?}
     */
    coerceValueForOperator(operator, value, rule) {
        /** @type {?} */
        const inputType = this.getInputType(rule.field, operator);
        if (inputType === 'multiselect' && !Array.isArray(value)) {
            return [value];
        }
        return value;
    }
    /**
     * @return {?}
     */
    changeInput() {
        if (this.disabled) {
            return;
        }
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} fieldValue
     * @param {?} rule
     * @return {?}
     */
    changeField(fieldValue, rule) {
        if (this.disabled) {
            return;
        }
        /** @type {?} */
        const inputContext = this.inputContextCache.get(rule);
        /** @type {?} */
        const currentField = inputContext && inputContext.field;
        /** @type {?} */
        const nextField = this.config.fields[fieldValue];
        /** @type {?} */
        const nextValue = this.calculateFieldChangeValue(currentField, nextField, rule.value);
        if (nextValue !== undefined) {
            rule.value = nextValue;
        }
        else {
            delete rule.value;
        }
        rule.operator = this.getDefaultOperator(nextField);
        // Create new context objects so templates will automatically update
        this.inputContextCache.delete(rule);
        this.operatorContextCache.delete(rule);
        this.fieldContextCache.delete(rule);
        this.entityContextCache.delete(rule);
        this.getInputContext(rule);
        this.getFieldContext(rule);
        this.getOperatorContext(rule);
        this.getEntityContext(rule);
        this.handleTouched();
        this.handleDataChange();
    }
    /**
     * @param {?} entityValue
     * @param {?} rule
     * @param {?} index
     * @param {?} data
     * @return {?}
     */
    changeEntity(entityValue, rule, index, data) {
        if (this.disabled) {
            return;
        }
        /** @type {?} */
        const entity = this.entities.find((/**
         * @param {?} e
         * @return {?}
         */
        (e) => e.value === entityValue));
        /** @type {?} */
        const defaultField = this.getDefaultField(entity);
        data.rules[index] = Object.assign({}, rule, { field: defaultField.value });
        if (defaultField) {
            this.changeField(defaultField.value, Object.assign({}, rule, { field: defaultField.value }));
        }
        else {
            this.handleTouched();
            this.handleDataChange();
        }
    }
    /**
     * @param {?} defaultValue
     * @return {?}
     */
    getDefaultValue(defaultValue) {
        switch (typeof defaultValue) {
            case 'function':
                return defaultValue();
            default:
                return defaultValue;
        }
    }
    /**
     * @return {?}
     */
    getOperatorTemplate() {
        /** @type {?} */
        const t = this.parentOperatorTemplate || this.operatorTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getFieldTemplate() {
        /** @type {?} */
        const t = this.parentFieldTemplate || this.fieldTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getEntityTemplate() {
        /** @type {?} */
        const t = this.parentEntityTemplate || this.entityTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getArrowIconTemplate() {
        /** @type {?} */
        const t = this.parentArrowIconTemplate || this.arrowIconTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getButtonGroupTemplate() {
        /** @type {?} */
        const t = this.parentButtonGroupTemplate || this.buttonGroupTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getSwitchGroupTemplate() {
        /** @type {?} */
        const t = this.parentSwitchGroupTemplate || this.switchGroupTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getRemoveButtonTemplate() {
        /** @type {?} */
        const t = this.parentRemoveButtonTemplate || this.removeButtonTemplate;
        return t ? t.template : null;
    }
    /**
     * @return {?}
     */
    getEmptyWarningTemplate() {
        /** @type {?} */
        const t = this.parentEmptyWarningTemplate || this.emptyWarningTemplate;
        return t ? t.template : null;
    }
    /**
     * @param {?} local
     * @return {?}
     */
    getQueryItemClassName(local) {
        /** @type {?} */
        let cls = this.getClassNames('row', 'connector', 'transition');
        cls += ' ' + this.getClassNames(local.ruleset ? 'ruleSet' : 'rule');
        if (local.invalid) {
            cls += ' ' + this.getClassNames('invalidRuleSet');
        }
        return cls;
    }
    /**
     * @return {?}
     */
    getButtonGroupContext() {
        if (!this.buttonGroupContext) {
            this.buttonGroupContext = {
                addRule: this.addRule.bind(this),
                addRuleSet: this.allowRuleset && this.addRuleSet.bind(this),
                removeRuleSet: this.allowRuleset && this.parentValue && this.removeRuleSet.bind(this),
                getDisabledState: this.getDisabledState,
                $implicit: this.data
            };
        }
        return this.buttonGroupContext;
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    getRemoveButtonContext(rule) {
        if (!this.removeButtonContextCache.has(rule)) {
            this.removeButtonContextCache.set(rule, {
                removeRule: this.removeRule.bind(this),
                getDisabledState: this.getDisabledState,
                $implicit: rule
            });
        }
        return this.removeButtonContextCache.get(rule);
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    getFieldContext(rule) {
        if (!this.fieldContextCache.has(rule)) {
            this.fieldContextCache.set(rule, {
                onChange: this.changeField.bind(this),
                getFields: this.getFields.bind(this),
                getDisabledState: this.getDisabledState,
                fields: this.fields,
                $implicit: rule
            });
        }
        return this.fieldContextCache.get(rule);
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    getEntityContext(rule) {
        if (!this.entityContextCache.has(rule)) {
            this.entityContextCache.set(rule, {
                onChange: this.changeEntity.bind(this),
                getDisabledState: this.getDisabledState,
                entities: this.entities,
                $implicit: rule
            });
        }
        return this.entityContextCache.get(rule);
    }
    /**
     * @return {?}
     */
    getSwitchGroupContext() {
        return {
            onChange: this.changeCondition.bind(this),
            getDisabledState: this.getDisabledState,
            $implicit: this.data
        };
    }
    /**
     * @return {?}
     */
    getArrowIconContext() {
        return {
            getDisabledState: this.getDisabledState,
            $implicit: this.data
        };
    }
    /**
     * @return {?}
     */
    getEmptyWarningContext() {
        return {
            getDisabledState: this.getDisabledState,
            message: this.emptyMessage,
            $implicit: this.data
        };
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    getOperatorContext(rule) {
        if (!this.operatorContextCache.has(rule)) {
            this.operatorContextCache.set(rule, {
                onChange: this.changeOperator.bind(this),
                getDisabledState: this.getDisabledState,
                operators: this.getOperators(rule.field),
                $implicit: rule
            });
        }
        return this.operatorContextCache.get(rule);
    }
    /**
     * @param {?} rule
     * @return {?}
     */
    getInputContext(rule) {
        if (!this.inputContextCache.has(rule)) {
            this.inputContextCache.set(rule, {
                onChange: this.changeInput.bind(this),
                getDisabledState: this.getDisabledState,
                options: this.getOptions(rule.field),
                field: this.config.fields[rule.field],
                $implicit: rule
            });
        }
        return this.inputContextCache.get(rule);
    }
    /**
     * @private
     * @param {?} currentField
     * @param {?} nextField
     * @param {?} currentValue
     * @return {?}
     */
    calculateFieldChangeValue(currentField, nextField, currentValue) {
        if (this.config.calculateFieldChangeValue != null) {
            return this.config.calculateFieldChangeValue(currentField, nextField, currentValue);
        }
        /** @type {?} */
        const canKeepValue = (/**
         * @return {?}
         */
        () => {
            if (currentField == null || nextField == null) {
                return false;
            }
            return currentField.type === nextField.type
                && this.defaultPersistValueTypes.indexOf(currentField.type) !== -1;
        });
        if (this.persistValueOnFieldChange && canKeepValue()) {
            return currentValue;
        }
        if (nextField && nextField.defaultValue !== undefined) {
            return this.getDefaultValue(nextField.defaultValue);
        }
        return undefined;
    }
    /**
     * @private
     * @param {?} ruleset
     * @return {?}
     */
    checkEmptyRuleInRuleset(ruleset) {
        if (!ruleset || !ruleset.rules || ruleset.rules.length === 0) {
            return true;
        }
        else {
            return ruleset.rules.some((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (item.rules) {
                    return this.checkEmptyRuleInRuleset(item);
                }
                else {
                    return false;
                }
            }));
        }
    }
    /**
     * @private
     * @param {?} ruleset
     * @param {?} errorStore
     * @return {?}
     */
    validateRulesInRuleset(ruleset, errorStore) {
        if (ruleset && ruleset.rules && ruleset.rules.length > 0) {
            ruleset.rules.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (((/** @type {?} */ (item))).rules) {
                    return this.validateRulesInRuleset((/** @type {?} */ (item)), errorStore);
                }
                else if (((/** @type {?} */ (item))).field) {
                    /** @type {?} */
                    const field = this.config.fields[((/** @type {?} */ (item))).field];
                    if (field && field.validator && field.validator.apply) {
                        /** @type {?} */
                        const error = field.validator((/** @type {?} */ (item)), ruleset);
                        if (error != null) {
                            errorStore.push(error);
                        }
                    }
                }
            }));
        }
    }
    /**
     * @private
     * @return {?}
     */
    handleDataChange() {
        this.changeDetectorRef.markForCheck();
        if (this.onChangeCallback) {
            this.onChangeCallback();
        }
        if (this.parentChangeCallback) {
            this.parentChangeCallback();
        }
    }
    /**
     * @private
     * @return {?}
     */
    handleTouched() {
        if (this.onTouchedCallback) {
            this.onTouchedCallback();
        }
        if (this.parentTouchedCallback) {
            this.parentTouchedCallback();
        }
    }
}
QueryBuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'query-builder',
                template: "<div [ngClass]=\"getClassNames('switchRow')\">\n  <ng-template #defaultArrowIcon>\n    <i [ngClass]=\"getClassNames('arrowIcon')\"></i>\n  </ng-template>\n\n  <a *ngIf=\"allowCollapse\" (click)=\"toggleCollapse()\" [ngClass]=\"getClassNames('arrowIconButton', data.collapsed ? 'collapsed' : null)\">\n    <ng-container *ngIf=\"getArrowIconTemplate() as template; else defaultArrowIcon\">\n      <ng-container *ngTemplateOutlet=\"template; context: getArrowIconContext()\"></ng-container>\n    </ng-container>\n  </a>\n\n  <ng-container *ngIf=\"getButtonGroupTemplate() as template; else defaultButtonGroup\">\n    <div [ngClass]=\"getClassNames('buttonGroup', 'rightAlign')\">\n      <ng-container *ngTemplateOutlet=\"template; context: getButtonGroupContext()\"></ng-container>\n    </div>\n  </ng-container>\n\n  <ng-template #defaultButtonGroup>\n    <div [ngClass]=\"getClassNames('buttonGroup', 'rightAlign')\">\n      <button type=\"button\" (click)=\"addRule()\" [ngClass]=\"getClassNames('button')\" [disabled]=disabled>\n        <i [ngClass]=\"getClassNames('addIcon')\"></i> Rule\n      </button>\n      <button type=\"button\" (click)=\"addRuleSet()\" [ngClass]=\"getClassNames('button')\" *ngIf=\"allowRuleset\" [disabled]=disabled>\n        <i [ngClass]=\"getClassNames('addIcon')\"></i> Ruleset\n      </button>\n      <ng-container *ngIf=\"!!parentValue && allowRuleset\">\n        <button type=\"button\" (click)=\"removeRuleSet()\" [ngClass]=\"getClassNames('button', 'removeButton')\" [disabled]=disabled>\n          <i [ngClass]=\"getClassNames('removeIcon')\"></i>\n        </button>\n      </ng-container>\n    </div>\n  </ng-template>\n\n  <ng-container *ngIf=\"getSwitchGroupTemplate() as template; else defaultSwitchGroup\">\n    <ng-container *ngTemplateOutlet=\"template; context: getSwitchGroupContext()\"></ng-container>\n  </ng-container>\n\n  <ng-template #defaultSwitchGroup>\n    <div [ngClass]=\"getClassNames('switchGroup', 'transition')\" *ngIf=\"data\">\n      <div [ngClass]=\"getClassNames('switchControl')\">\n        <input type=\"radio\" [ngClass]=\"getClassNames('switchRadio')\" [(ngModel)]=\"data.condition\" [disabled]=disabled\n          value=\"and\" #andOption />\n        <label (click)=\"changeCondition(andOption.value)\" [ngClass]=\"getClassNames('switchLabel')\">AND</label>\n      </div>\n      <div [ngClass]=\"getClassNames('switchControl')\">\n        <input type=\"radio\" [ngClass]=\"getClassNames('switchRadio')\" [(ngModel)]=\"data.condition\" [disabled]=disabled\n          value=\"or\" #orOption />\n        <label (click)=\"changeCondition(orOption.value)\" [ngClass]=\"getClassNames('switchLabel')\">OR</label>\n      </div>\n    </div>\n  </ng-template>\n</div>\n\n<div #treeContainer (transitionend)=\"transitionEnd($event)\" [ngClass]=\"getClassNames('treeContainer', data.collapsed ? 'collapsed' : null)\">\n  <ul [ngClass]=\"getClassNames('tree')\" *ngIf=\"data && data.rules\">\n    <ng-container *ngFor=\"let rule of data.rules;let i=index\">\n\n      <ng-container *ngIf=\"{ruleset: !!rule.rules, invalid: !config.allowEmptyRulesets && rule.rules && rule.rules.length === 0} as local\">\n        <li [ngClass]=\"getQueryItemClassName(local)\">\n          <ng-container *ngIf=\"!local.ruleset\">\n\n            <ng-container *ngIf=\"getRemoveButtonTemplate() as template; else defaultRemoveButton\">\n              <div [ngClass]=\"getClassNames('buttonGroup', 'rightAlign')\">\n                <ng-container *ngTemplateOutlet=\"template; context: getRemoveButtonContext(rule)\"></ng-container>\n              </div>\n            </ng-container>\n\n            <ng-template #defaultRemoveButton>\n              <div [ngClass]=\"getClassNames('removeButtonSize', 'rightAlign')\">\n                <button type=\"button\" [ngClass]=\"getClassNames('button', 'removeButton')\" (click)=\"removeRule(rule, data)\" [disabled]=disabled>\n                  <i [ngClass]=\"getClassNames('removeIcon')\"></i>\n                </button>\n              </div>\n            </ng-template>\n\n            <div *ngIf=\"entities?.length > 0\" class=\"q-inline-block-display\">\n              <ng-container *ngIf=\"getEntityTemplate() as template; else defaultEntity\">\n                <ng-container *ngTemplateOutlet=\"template; context: getEntityContext(rule)\"></ng-container>\n              </ng-container>\n            </div>\n\n            <ng-template #defaultEntity>\n              <div [ngClass]=\"getClassNames('entityControlSize')\">\n                <select [ngClass]=\"getClassNames('entityControl')\" [(ngModel)]=\"rule.entity\" (ngModelChange)=\"changeEntity($event, rule,i,data)\"\n                  [disabled]=\"disabled\">\n                  <option *ngFor=\"let entity of entities\" [ngValue]=\"entity.value\">\n                    {{entity.name}}\n                  </option>\n                </select>\n              </div>\n            </ng-template>\n\n            <ng-container *ngIf=\"getFieldTemplate() as template; else defaultField\">\n              <ng-container *ngTemplateOutlet=\"template; context: getFieldContext(rule)\"></ng-container>\n            </ng-container>\n\n            <ng-template #defaultField>\n              <div [ngClass]=\"getClassNames('fieldControlSize')\">\n                <select [ngClass]=\"getClassNames('fieldControl')\" [(ngModel)]=\"rule.field\" (ngModelChange)=\"changeField($event, rule)\"\n                  [disabled]=\"disabled\">\n                  <option *ngFor=\"let field of getFields(rule.entity)\" [ngValue]=\"field.value\">\n                    {{field.name}}\n                  </option>\n                </select>\n              </div>\n            </ng-template>\n\n            <ng-container *ngIf=\"getOperatorTemplate() as template; else defaultOperator\">\n              <ng-container *ngTemplateOutlet=\"template; context: getOperatorContext(rule)\"></ng-container>\n            </ng-container>\n\n            <ng-template #defaultOperator>\n              <div [ngClass]=\"getClassNames('operatorControlSize')\">\n                <select [ngClass]=\"getClassNames('operatorControl')\" [(ngModel)]=\"rule.operator\" (ngModelChange)=\"changeOperator(rule)\"\n                  [disabled]=\"disabled\">\n                  <option *ngFor=\"let operator of getOperators(rule.field)\" [ngValue]=\"operator\">\n                    {{operator}}\n                  </option>\n                </select>\n              </div>\n            </ng-template>\n\n            <ng-container *ngIf=\"findTemplateForRule(rule) as template; else defaultInput\">\n              <ng-container *ngTemplateOutlet=\"template; context: getInputContext(rule)\"></ng-container>\n            </ng-container>\n\n            <ng-template #defaultInput>\n              <div [ngClass]=\"getClassNames('inputControlSize')\" [ngSwitch]=\"getInputType(rule.field, rule.operator)\">\n                <input [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'string'\" type=\"text\">\n                <input [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'number'\" type=\"number\">\n                <input [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'date'\" type=\"date\">\n                <input [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'time'\" type=\"time\">\n                <select [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'category'\">\n                  <option *ngFor=\"let opt of getOptions(rule.field)\" [ngValue]=\"opt.value\">\n                    {{opt.name}}\n                  </option>\n                </select>\n                <ng-container *ngSwitchCase=\"'multiselect'\">\n                  <select [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                    [disabled]=\"disabled\" multiple>\n                    <option *ngFor=\"let opt of getOptions(rule.field)\" [ngValue]=\"opt.value\">\n                      {{opt.name}}\n                    </option>\n                  </select>\n                </ng-container>\n                <input [ngClass]=\"getClassNames('inputControl')\" [(ngModel)]=\"rule.value\" (ngModelChange)=\"changeInput()\"\n                  [disabled]=\"disabled\" *ngSwitchCase=\"'boolean'\" type=\"checkbox\">\n              </div>\n            </ng-template>\n\n          </ng-container>\n          <query-builder *ngIf=\"local.ruleset\" [data]=\"rule\" [disabled]=\"disabled\" [parentTouchedCallback]=\"parentTouchedCallback || onTouchedCallback\"\n            [parentChangeCallback]=\"parentChangeCallback || onChangeCallback\" [parentInputTemplates]=\"parentInputTemplates || inputTemplates\"\n            [parentOperatorTemplate]=\"parentOperatorTemplate || operatorTemplate\" [parentFieldTemplate]=\"parentFieldTemplate || fieldTemplate\"\n            [parentEntityTemplate]=\"parentEntityTemplate || entityTemplate\" [parentSwitchGroupTemplate]=\"parentSwitchGroupTemplate || switchGroupTemplate\"\n            [parentButtonGroupTemplate]=\"parentButtonGroupTemplate || buttonGroupTemplate\" [parentRemoveButtonTemplate]=\"parentRemoveButtonTemplate || removeButtonTemplate\"\n            [parentEmptyWarningTemplate]=\"parentEmptyWarningTemplate || emptyWarningTemplate\" [parentArrowIconTemplate]=\"parentArrowIconTemplate || arrowIconTemplate\"\n            [parentValue]=\"data\" [classNames]=\"classNames\" [config]=\"config\" [allowRuleset]=\"allowRuleset\"\n            [allowCollapse]=\"allowCollapse\" [emptyMessage]=\"emptyMessage\" [operatorMap]=\"operatorMap\">\n          </query-builder>\n\n          <ng-container *ngIf=\"getEmptyWarningTemplate() as template; else defaultEmptyWarning\">\n            <ng-container *ngIf=\"local.invalid\">\n              <ng-container *ngTemplateOutlet=\"template; context: getEmptyWarningContext()\"></ng-container>\n            </ng-container>\n          </ng-container>\n\n          <ng-template #defaultEmptyWarning>\n            <p [ngClass]=\"getClassNames('emptyWarning')\" *ngIf=\"local.invalid\">\n              {{emptyMessage}}\n            </p>\n          </ng-template>\n        </li>\n      </ng-container>\n    </ng-container>\n  </ul>\n</div>",
                providers: [CONTROL_VALUE_ACCESSOR, VALIDATOR],
                styles: ["@charset \"UTF-8\";:host{display:block;width:100%}:host .q-icon{font-style:normal;font-size:12px}:host .q-remove-icon::before{content:\"\u274C\"}:host .q-arrow-icon-button{float:left;margin:4px 6px 4px 0;-webkit-transform:rotate(90deg);transform:rotate(90deg);-webkit-transition:transform .25s linear;transition:transform .25s linear;cursor:pointer}:host .q-arrow-icon-button.q-collapsed{-webkit-transform:rotate(0);transform:rotate(0)}:host .q-arrow-icon::before{content:\"\u25B6\"}:host .q-add-icon{color:#555}:host .q-add-icon::before{content:\"\u2795\"}:host .q-remove-button{color:#b3415d;width:31px}:host .q-button-group,:host .q-switch-group{font-family:\"Lucida Grande\",Tahoma,Verdana,sans-serif;overflow:hidden}:host .q-right-align{float:right}:host .q-button{margin-left:8px;padding:0 8px;background-color:#fff}:host .q-button:disabled{display:none}:host .q-control-size{display:inline-block;vertical-align:top;padding-right:10px}:host .q-entity-control,:host .q-field-control,:host .q-input-control,:host .q-operator-control{display:inline-block;padding:5px 8px;color:#555;background-color:#fff;background-image:none;border:1px solid #ccc;border-radius:4px;box-sizing:border-box;width:auto}:host .q-entity-control:disabled,:host .q-field-control:disabled,:host .q-input-control:disabled,:host .q-operator-control:disabled{border-color:transparent}:host .q-entity-control,:host .q-field-control,:host .q-input-control:not([type=checkbox]),:host .q-operator-control{min-height:32px;-webkit-appearance:none}:host .q-button,:host .q-switch-label{float:left;margin-bottom:0;font-size:14px;line-height:30px;font-weight:400;text-align:center;text-shadow:none;border:1px solid rgba(0,0,0,.2);box-sizing:border-box}:host .q-button:hover,:host .q-switch-label:hover{cursor:pointer;background-color:#f0f0f0}:host .q-switch-label{background-color:#e4e4e4;padding:0 8px}:host .q-switch-radio{position:absolute;clip:rect(0,0,0,0);height:1px;width:1px;border:0;overflow:hidden}:host .q-switch-radio:checked+.q-switch-label{border:1px solid #619ed7;background:#fff;color:#3176b3}:host .q-switch-radio:disabled+.q-switch-label{display:none}:host .q-switch-radio:checked:disabled+.q-switch-label{display:initial;color:initial;cursor:default;border-color:transparent}:host .q-invalid-ruleset{border:1px solid rgba(179,65,93,.5)!important;background:rgba(179,65,93,.1)!important}:host .q-empty-warning{color:#8d252e;text-align:center}:host .q-ruleset{border:1px solid #ccc}:host .q-rule{border:1px solid #ccc;background:#fff}:host .q-transition{-webkit-transition:.1s ease-in-out;transition:.1s ease-in-out}:host .q-tree-container{width:100%;overflow:hidden;-webkit-transition:max-height .25s ease-in;transition:max-height .25s ease-in}:host .q-tree-container.q-collapsed{max-height:0!important}:host .q-tree{list-style:none;margin:4px 0 2px}:host .q-row{padding:6px 8px;margin-top:6px}:host .q-connector{position:relative}:host .q-connector::before{top:-5px;border-width:0 0 2px 2px}:host .q-connector::after{border-width:0 0 0 2px;top:50%}:host .q-connector::after,:host .q-connector::before{content:\"\";left:-12px;border-color:#ccc;border-style:solid;width:9px;height:calc(50% + 6px);position:absolute}:host .q-connector:last-child::after{content:none}:host .q-inline-block-display{display:inline-block;vertical-align:top}"]
            }] }
];
/** @nocollapse */
QueryBuilderComponent.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
QueryBuilderComponent.propDecorators = {
    disabled: [{ type: Input }],
    data: [{ type: Input }],
    allowRuleset: [{ type: Input }],
    allowCollapse: [{ type: Input }],
    emptyMessage: [{ type: Input }],
    classNames: [{ type: Input }],
    operatorMap: [{ type: Input }],
    parentValue: [{ type: Input }],
    config: [{ type: Input }],
    parentArrowIconTemplate: [{ type: Input }],
    parentInputTemplates: [{ type: Input }],
    parentOperatorTemplate: [{ type: Input }],
    parentFieldTemplate: [{ type: Input }],
    parentEntityTemplate: [{ type: Input }],
    parentSwitchGroupTemplate: [{ type: Input }],
    parentButtonGroupTemplate: [{ type: Input }],
    parentRemoveButtonTemplate: [{ type: Input }],
    parentEmptyWarningTemplate: [{ type: Input }],
    parentChangeCallback: [{ type: Input }],
    parentTouchedCallback: [{ type: Input }],
    persistValueOnFieldChange: [{ type: Input }],
    treeContainer: [{ type: ViewChild, args: ['treeContainer', { static: true },] }],
    buttonGroupTemplate: [{ type: ContentChild, args: [QueryButtonGroupDirective, { static: false },] }],
    switchGroupTemplate: [{ type: ContentChild, args: [QuerySwitchGroupDirective, { static: false },] }],
    fieldTemplate: [{ type: ContentChild, args: [QueryFieldDirective, { static: false },] }],
    entityTemplate: [{ type: ContentChild, args: [QueryEntityDirective, { static: false },] }],
    operatorTemplate: [{ type: ContentChild, args: [QueryOperatorDirective, { static: false },] }],
    removeButtonTemplate: [{ type: ContentChild, args: [QueryRemoveButtonDirective, { static: false },] }],
    emptyWarningTemplate: [{ type: ContentChild, args: [QueryEmptyWarningDirective, { static: false },] }],
    inputTemplates: [{ type: ContentChildren, args: [QueryInputDirective,] }],
    arrowIconTemplate: [{ type: ContentChild, args: [QueryArrowIconDirective, { static: false },] }],
    value: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    QueryBuilderComponent.prototype.fields;
    /** @type {?} */
    QueryBuilderComponent.prototype.filterFields;
    /** @type {?} */
    QueryBuilderComponent.prototype.entities;
    /** @type {?} */
    QueryBuilderComponent.prototype.defaultClassNames;
    /** @type {?} */
    QueryBuilderComponent.prototype.defaultOperatorMap;
    /** @type {?} */
    QueryBuilderComponent.prototype.disabled;
    /** @type {?} */
    QueryBuilderComponent.prototype.data;
    /** @type {?} */
    QueryBuilderComponent.prototype.onChangeCallback;
    /** @type {?} */
    QueryBuilderComponent.prototype.onTouchedCallback;
    /** @type {?} */
    QueryBuilderComponent.prototype.allowRuleset;
    /** @type {?} */
    QueryBuilderComponent.prototype.allowCollapse;
    /** @type {?} */
    QueryBuilderComponent.prototype.emptyMessage;
    /** @type {?} */
    QueryBuilderComponent.prototype.classNames;
    /** @type {?} */
    QueryBuilderComponent.prototype.operatorMap;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentValue;
    /** @type {?} */
    QueryBuilderComponent.prototype.config;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentArrowIconTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentInputTemplates;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentOperatorTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentFieldTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentEntityTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentSwitchGroupTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentButtonGroupTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentRemoveButtonTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentEmptyWarningTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentChangeCallback;
    /** @type {?} */
    QueryBuilderComponent.prototype.parentTouchedCallback;
    /** @type {?} */
    QueryBuilderComponent.prototype.persistValueOnFieldChange;
    /** @type {?} */
    QueryBuilderComponent.prototype.treeContainer;
    /** @type {?} */
    QueryBuilderComponent.prototype.buttonGroupTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.switchGroupTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.fieldTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.entityTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.operatorTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.removeButtonTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.emptyWarningTemplate;
    /** @type {?} */
    QueryBuilderComponent.prototype.inputTemplates;
    /** @type {?} */
    QueryBuilderComponent.prototype.arrowIconTemplate;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.defaultTemplateTypes;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.defaultPersistValueTypes;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.defaultEmptyList;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.operatorsCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.inputContextCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.operatorContextCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.fieldContextCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.entityContextCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.removeButtonContextCache;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.buttonGroupContext;
    /** @type {?} */
    QueryBuilderComponent.prototype.getDisabledState;
    /**
     * @type {?}
     * @private
     */
    QueryBuilderComponent.prototype.changeDetectorRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class QueryBuilderModule {
}
QueryBuilderModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule
                ],
                declarations: [
                    QueryBuilderComponent,
                    QueryInputDirective,
                    QueryOperatorDirective,
                    QueryFieldDirective,
                    QueryEntityDirective,
                    QueryButtonGroupDirective,
                    QuerySwitchGroupDirective,
                    QueryRemoveButtonDirective,
                    QueryEmptyWarningDirective,
                    QueryArrowIconDirective
                ],
                exports: [
                    QueryBuilderComponent,
                    QueryInputDirective,
                    QueryOperatorDirective,
                    QueryFieldDirective,
                    QueryEntityDirective,
                    QueryButtonGroupDirective,
                    QuerySwitchGroupDirective,
                    QueryRemoveButtonDirective,
                    QueryEmptyWarningDirective,
                    QueryArrowIconDirective
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CONTROL_VALUE_ACCESSOR, QueryArrowIconDirective, QueryBuilderComponent, QueryBuilderModule, QueryButtonGroupDirective, QueryEmptyWarningDirective, QueryEntityDirective, QueryFieldDirective, QueryInputDirective, QueryOperatorDirective, QueryRemoveButtonDirective, QuerySwitchGroupDirective, VALIDATOR };
//# sourceMappingURL=angular2-query-builder.js.map
